#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#define globals_main
#include "main.h"
#include <util/delay.h>
//#include "ili9320.h"
#include "lcd_select.h"
#include "i2cmaster.h"
#include "irint.h"
//#include "owx.h"

v u8 wtstep;
v u8 wavetable[48]={	
255,255,255,255, 255,255,255,255, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
255,255,255,255, 255,255,255,255, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
				};

v u8 tbl_freq[10]={220,200,170,165,160,133,100,80,40,26};
v u8 tbl_freq_step=0;
//v u8 tbl_freq_step_max=8;

v u8 pwm_wert=0;
v u8 tbl_pulsewidth[10]={255,250,245,240,235,230,225,220,215,210};
v u8 tbl_pulsewidth_step=0;

v u8 tmpul_old,tmpvl_old,tmpwl_old,tmpuh_old,tmpvh_old,tmpwh_old;
v u16 zl_freq;

v u16 zly,zlyy=150;
v u8 drehstop=0; 


v	u8 tmpul,tmpvl,tmpwl,tmpuh,tmpvh,tmpwh;

v u8 zl_step, max_step=24;


u8 fb_color_mnu=0;
v u8 wert_x=30;


#define u_set_h OCR0B=pwm_wert
#define u_set_l OCR0A=pwm_wert
#define u_set_z OCR0A=255;OCR0B=255

#define v_set_h OCR1B=pwm_wert
#define v_set_l OCR1A=pwm_wert
#define v_set_z OCR1A=255;OCR1B=255

#define w_set_h OCR2B=pwm_wert
#define w_set_l OCR2A=pwm_wert
#define w_set_z OCR2A=255;OCR2B=255



//==========================================


#define ti_prescaler_clr   ((1 << CS02)|(1 << CS01)|(1 << CS00))

#define ti_prescaler_1     (1 << CS00)
#define ti_prescaler_8     (1 << CS01)
#define ti_prescaler_64_32    (1 << CS01)|(1 << CS00)
#define ti_prescaler_256_64   (1 << CS02)
#define ti_prescaler_1024_128  (1 << CS02)|(1 << CS00)


//=====================================================
void init_timer_smh(void);
void sub_owx_rx(void);



blcd_one_step(){

zl_step++;
if(zl_step>(max_step-1)){
	zl_step=0;
	led1_tog;
	}
	
	
	tmpuh=(wavetable[zl_step]);
	tmpul=(wavetable[zl_step+12]);
	tmpvh=(wavetable[zl_step+8]);
	tmpvl=(wavetable[zl_step+20]);
	tmpwh=(wavetable[zl_step+16]);
	tmpwl=(wavetable[zl_step+4]);

	tmpuh_old=tmpuh;
	tmpul_old=tmpul;
	tmpvh_old=tmpvh;
	tmpvl_old=tmpvl;
	tmpwh_old=tmpwh;
	tmpwl_old=tmpwl;

/*
	OCR0B =255- tmpuh;
	OCR1B =255- tmpvh;
	OCR2B =255- tmpwh;
	OCR0A =255- tmpul;
	OCR1A =255- tmpvl;
	OCR2A =255- tmpwl;
*/

u8 pwm=tbl_pulsewidth[tbl_pulsewidth_step];

	if(!tmpuh || tmpuh_old)	 OCR0B =255- (u16)tmpuh*pwm/255;
	if(!tmpvh || tmpvh_old)	 OCR1B =255- (u16)tmpvh*pwm/255;
	if(!tmpwh || tmpwh_old)	 OCR2B =255- (u16)tmpwh*pwm/255;
	if(!tmpul || tmpul_old)	 OCR0A =255- (u16)tmpul*pwm/255;
	if(!tmpvl || tmpvl_old)	 OCR1A =255- (u16)tmpvl*pwm/255;
	if(!tmpwl || tmpwl_old)	 OCR2A =255- (u16)tmpwl*pwm/255;

//deadtime
_delay_us(2);


	if(tmpuh && !tmpul_old)OCR0B =255- tmpuh;
	if(tmpvh && !tmpvh_old)OCR1B =255- tmpvh;
	if(tmpwh && !tmpwh_old)OCR2B =255- tmpwh;
	if(tmpul && !tmpul_old)OCR0A =255- tmpul;
	if(tmpvl && !tmpvl_old)OCR1A =255- tmpvl;
	if(tmpwl && !tmpwl_old)OCR2A =255- tmpwl;



}









//=====================================================
#define fb_left 0xdd
#define fb_right 0x3d
#define fb_up 0x9d
#define fb_down 0x57
#define fb_0 0xb5
#define fb_1 0x97
#define fb_2 0x67
#define fb_3 0x4f
#define fb_4 0xcf
#define fb_5 0xe7
#define fb_6 0x85
#define fb_7 0xef
#define fb_8 0xc7
#define fb_9 0xa5
#define fb_ok 0xfd
#define fb_stern 0xbd
#define fb_raute 0xad


void sub_ir_anwendung(u8 cmd){
  switch (cmd)
  {
  
     case (fb_0):
      	    u_set_h;
  lg(2,4);lcd_write("+u");
     break;

    case (fb_1):
      	   u_set_l;
 lg(2,6);lcd_write("-u");
     break;

    case (fb_2):
	   v_set_h;
  lg(2,8);lcd_write("+v");
     break;

    case (fb_3):
	   v_set_l;
  lg(2,10);lcd_write("-v");
     break;

    case (fb_4):
	  w_set_h;
  lg(2,12);lcd_write("+w");
     break;

    case (fb_5):
 	   w_set_l;
 lg(2,14);lcd_write("-w");
    break;
   case (fb_6):
 	  u_set_z;  v_set_z;  w_set_z;
lg(2,4);lcd_write("               ");
     break;
  

   case (fb_left):
 if(tbl_freq_step<10)tbl_freq_step++;
lg(2,4);lcd_write("+");lcd_int4(tbl_freq[tbl_freq_step]);
     break;

  case (fb_right):
if(tbl_freq_step>0)tbl_freq_step--;
lg(2,4);lcd_write("-");lcd_int4(tbl_freq[tbl_freq_step]);
     break;


   case (fb_up):
if(tbl_pulsewidth_step<10)tbl_pulsewidth_step++;
lg(2,4);lcd_write("+");lcd_int4(tbl_pulsewidth[tbl_pulsewidth_step]);
     break;

   case (fb_down):
if(tbl_pulsewidth_step>0)tbl_pulsewidth_step--;
lg(2,4);lcd_write("-");lcd_int4(tbl_pulsewidth[tbl_pulsewidth_step]);
     break;

case(fb_ok):
zl_step+=3;
blcd_one_step();
lg(2,4);lcd_write("step");lcd_int4(zl_step);

break;


    case (fb_stern)://7
	if(drehstop){
	drehstop=0;
lg(2,4);lcd_write("start");
	}else{
 	  u_set_z;  v_set_z;  w_set_z;
	drehstop=1;
lg(2,4);lcd_write("stop ");
	
	}
	
	

}//switch

} 

static void pwm_timer_init(void)
{
    ICR1 = 0xFF; // set TOP to 16bit
 
    // set none-inverting mode
    TCCR1A |= (1 << COM1A1)|(1 << COM1B1);

    // set Fast PWM mode using ICR1 as TOP
    TCCR1A |= (1 << WGM11);
    TCCR1B |= (1 << WGM12)|(1 << WGM13);
    

    TCCR0A |= (1 << COM0A1)|(1 << COM0B1);
    // set none-inverting mode
    TCCR0A |= (1 << WGM01) | (1 << WGM00);
    // set fast PWM Mode



    TCCR2A |= (1 << COM2A1)|(1 << COM2B1);
    // set none-inverting mode
    TCCR2A |= (1 << WGM21) | (1 << WGM20);
    // set fast PWM Mode
 
 
TCCR0B |= ti_prescaler_1;//1
TCCR2B |= ti_prescaler_1;//1
TCCR1B |= ti_prescaler_1;//1

    OCR1A = 255;
    OCR1B = 255;
  OCR0A = 255;
   OCR0B = 255;
  OCR2A = 255;
  OCR2B = 255;
  
 
  DDRB |= (1 << 3); DDRD |= (1 << 3);
  DDRB |= (1 << 1) | (1 << 2);
  DDRD |= (1 << 5) | (1 << 6);
  
  // Enable Timer1 capture event interrupt.
 // TIFR0 = _BV(ICF1) | _BV(OCF1B) | _BV(OCF1A) | _BV(TOV1) ;
//  TIMSK0 = 
//  TCCR0A |= (1 << WGM01);

  TIMSK0 |= (1 << OCIE0A);    //Set the ISR COMPA vect
 //  TIMSK0 |= (1 << TOIE0);    //Set the ISR ovf vect
 // Enable Timer1 capture event interrupt.

//  TIFR1 = (1<<ICF1) | (1<<OCF1B) | (1<<OCF1A) | (1<<TOV1) ;
//  TIMSK1 = (1<<ICIE1);

sei();
}



v u16 tim;
v u8 sec_change;
ISR(TIMER0_COMPA_vect)
{
TIM3_CNT++;
tim++;
zl_freq++;
if(zl_freq>tbl_freq[tbl_freq_step]){
zl_freq=0;
if(!drehstop)blcd_one_step();
}

if(tim>28000){
	sec++;//=sectimer_smh/1000;
	sec_change=1;	//timer_smh=0;//timer_smh%1000;
			if(sec>59){
				sec=sec-60;	min=min+1;
					if(min==60){
						min=0; hou++;
						if(hou==24){hou=0;}
					}
			}
	led1_tog;
	tim=0;
	}
}


//==========================================
//==========================================
void main(void){
u8 ret;

std_init();
ir_sens_init();
	
//lcd_clear(YELLOW);
lcd_goto(1,1);	
lcd_write(" test");

pwm_timer_init();

//test();
while(1){
//================= ir polling ======================
/*		if(ir_pin){
//			led1_on;
			signalauswertung();
			_delay_ms(100);//prellung
//			led1_off;
		}//ir_pin*/	
//================= ir polling ======================
//================= owx polling ======================
timer_10ms++;
if(timer_10ms>2599){
timer_10ms=0;
if(down_timer1)down_timer1--;
timer_smh++;
				if(!down_timer1 && ir_start){
					sub_ir_end();
				}
}

if(!fb_color_mnu){	//                =	

	if (sec_change){
			
		sec_change=0;
//led1_tog;

		lcd_goto(1,7);//              =
		lcd_int2(sec);//              =
//=================== ab hier sec-code ==================	


//led1_off;
if(sec%6==0){
//w_set_z;u_set_h;v_set_l;
}		




//=====================================	
if(sec==0){//min
		lcd_goto(1,1);
		lcd_int2(hou);lw(":");
		lcd_int2(min);lw(":");
		
		

//=============== ab hier min-code =====================


//============== hou ======================
if (min ==33){//hou
//========= ab hier hou-code =====================



}//hou   	
}//min
}// fb_color_mnu
}//sec
}//while
}


//----------------------------------



//===========================================
//===========================================
//===========================================
//===========================================
//-----------------------------------------------------------
 

//===========================================

void timer_proc_10ms(void){
//7812/78 =>9,9846ms
    //led1_tog;
	TIM3_CNT++;
    timer_smh++;
    if(down_timer1)down_timer1--;//100Hz f?r sd-karte
	
}

/*
ISR(TIMER0_COMPA_vect){

timer_proc_10ms();
}
*/

void sub_owx_rx(void){
;
}

//-----------------------------------------------------------
